﻿Imports System.Collections.ObjectModel
Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Public Class CustomMsSQLFeatureSource
   Inherits MsSql2008FeatureSource

   Public Sub New()
      MyBase.New(String.Empty, String.Empty, String.Empty, 4326)
   End Sub

   Public Sub New(ByVal connectionString As String, ByVal tableName As String, ByVal featureIdColumn As String)
      MyBase.new(connectionString, tableName, featureIdColumn, 4326)
   End Sub

   Public Sub New(ByVal connectionString As String, ByVal tableName As String, ByVal featureIdColumn As String, ByVal srid As Integer)
      MyBase.new(connectionString, tableName, featureIdColumn, srid)
   End Sub

   Protected Overrides Function GetFeaturesInsideBoundingBoxCore(ByVal boundingBox As ThinkGeo.MapSuite.Core.RectangleShape, ByVal returningColumnNames As System.Collections.Generic.IEnumerable(Of String)) As Collection(Of ThinkGeo.MapSuite.Core.Feature)
      Dim featuresInsideBoundingBox As Collection(Of Feature) = MyBase.GetFeaturesInsideBoundingBoxCore(boundingBox, returningColumnNames)

      If featuresInsideBoundingBox.Count = 0 Then

         Dim allFeatures As Collection(Of Feature) = GetAllFeatures(ReturningColumnsType.AllColumns)

         For Each oFeature As Feature In allFeatures

            If boundingBox.Intersects(oFeature.GetBoundingBox()) Then
               featuresInsideBoundingBox.Add(oFeature)
            End If
         Next oFeature
      End If
      Return featuresInsideBoundingBox

   End Function

End Class
Public Class CustomMSSqlFeatureLayer
   Inherits MsSql2008FeatureLayer

   Public Sub New()
      MyBase.New()
   End Sub





End Class
